"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Md2jsx = void 0;
/*
 * @Author: saber2pr
 * @Date: 2019-07-15 08:49:51
 * @Last Modified by: saber2pr
 * @Last Modified time: 2020-04-07 14:10:59
 */
var react_1 = __importStar(require("react"));
var clipboard_1 = __importDefault(require("clipboard"));
var prism_light_1 = __importDefault(require("react-syntax-highlighter/dist/cjs/prism-light"));
var create_element_1 = __importDefault(require("react-syntax-highlighter/dist/cjs/create-element"));
var SyntaxHighlighter = prism_light_1.default;
var reg_1 = require("../../reg");
var core_1 = require("../../core");
require("./style.less");
function Md2jsx(_a) {
    var children = _a.children, theme = _a.theme;
    var jsx = [];
    var lines = core_1.mergeCode(children.split(/\n|\r\n/));
    var codeIdx = 0;
    for (var i = 0; i < lines.length; ++i) {
        var line = lines[i];
        if (line.startsWith('```')) {
            renderCode({ jsx: jsx, i: i, line: line, theme: theme, blockIndex: codeIdx });
            codeIdx++;
        }
        else if (line.startsWith('#')) {
            renderHeader({ jsx: jsx, i: i, line: line });
        }
        else if (line.startsWith('>')) {
            renderComment({ jsx: jsx, i: i, line: line });
        }
        else if (reg_1.REG.imgtype.test(line)) {
            renderImg({ jsx: jsx, i: i, line: line });
        }
        else if (reg_1.REG.atype_url.test(line)) {
            renderAnchor({ jsx: jsx, i: i, line: line });
        }
        else if (line.startsWith('---') || line.startsWith('***')) {
            renderHR({ jsx: jsx, i: i, line: line });
        }
        else {
            jsx.push(react_1.default.createElement("p", { key: i, dangerouslySetInnerHTML: {
                    __html: line.replace(/\t/g, '&nbsp;&nbsp;'),
                } }));
        }
    }
    codeIdx = 0;
    return react_1.default.createElement(react_1.default.Fragment, null, jsx);
}
exports.Md2jsx = Md2jsx;
(function (Md2jsx) {
    Md2jsx.registerLanguage = function (name, meta) {
        return SyntaxHighlighter.registerLanguage(name, meta);
    };
})(Md2jsx = exports.Md2jsx || (exports.Md2jsx = {}));
var getText = function (token) {
    var children = token === null || token === void 0 ? void 0 : token.children;
    if (Array.isArray(children)) {
        return children.map(function (node) {
            if (node.type === 'text') {
                return node.value;
            }
            return '';
        }).join('');
    }
    return '';
};
var getStartPos = function (token) {
    var pref = token.match(/^( +)/);
    if (pref) {
        return pref[1].length;
    }
    return 0;
};
var rowRenderer = function (blockIndex, lang) { return function (_a) {
    var rows = _a.rows, stylesheet = _a.stylesheet, useInlineStyles = _a.useInlineStyles;
    return rows.map(function (node, i) {
        var tokens = Array.isArray(node.children) ? node.children : [];
        var currentIndex = 0;
        node.children = tokens.map(function (token) {
            var _a;
            var properties = (_a = token.properties) !== null && _a !== void 0 ? _a : {};
            var text = getText(token);
            if (/ /.test(text)) {
            }
            else {
                var tokenWord = text.trim();
                if (tokenWord && tokenWord !== '.') {
                    properties["data-" + blockIndex + "-" + lang + "-token"] = tokenWord + "-" + i + "-" + (currentIndex + getStartPos(text));
                }
            }
            token.properties = properties;
            currentIndex += text.length;
            return token;
        });
        return create_element_1.default({
            node: node,
            stylesheet: stylesheet,
            useInlineStyles: useInlineStyles,
            key: "code-segement" + i
        });
    });
}; };
var renderCode = function (_a) {
    var line = _a.line, jsx = _a.jsx, theme = _a.theme, i = _a.i, blockIndex = _a.blockIndex;
    var codetype = reg_1.REG.codetype.exec(line)[0].slice(3);
    var code = line.slice(codetype.length + 4, line.length - 4);
    var Code = function () {
        var id = 'MD2JSX-Code-' + i;
        return (react_1.default.createElement("div", { className: "MD2JSX-Code" },
            react_1.default.createElement("div", { title: "\u590D\u5236\u5230\u526A\u8D34\u677F", className: "Paste", ref: function (el) {
                    if (el) {
                        new clipboard_1.default(el);
                    }
                }, "data-clipboard-target": '#' + id },
                react_1.default.createElement("i", { className: "iconfont icon-fuzhi" })),
            react_1.default.createElement("div", { id: id },
                react_1.default.createElement(SyntaxHighlighter, { language: codetype, style: theme, renderer: rowRenderer(blockIndex, codetype) }, code))));
    };
    jsx.push(react_1.default.createElement(Code, { key: i }));
};
var renderHeader = function (_a) {
    var line = _a.line, jsx = _a.jsx, i = _a.i;
    var count = 0;
    var text = '';
    for (var _i = 0, line_1 = line; _i < line_1.length; _i++) {
        var ch = line_1[_i];
        if (ch === '#') {
            count++;
        }
        else {
            text += ch;
        }
    }
    jsx.push(react_1.default.createElement(react_1.Fragment, { key: i }, react_1.default.createElement("h" + count, null, text)));
};
var renderComment = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    jsx.push(react_1.default.createElement("p", { key: i, style: {
            color: 'gray',
            borderLeft: '0.2rem solid #d0d0d0',
            paddingLeft: '0.5rem',
        } }, line.slice(2)));
};
var renderImg = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    var meta = line.match(reg_1.REG.imgtype)[0];
    var title = meta.match(reg_1.REG.imgtype_title)[0].replace(/\[|\]/g, '');
    var url = meta.match(reg_1.REG.imgtype_url)[0].replace(/\(|\)/g, '');
    jsx.push(react_1.default.createElement("img", { key: i, src: url, alt: title, style: { maxWidth: '100%' } }));
};
var renderAnchor = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    var meta = line.match(reg_1.REG.atype_url)[0];
    var title = meta.match(reg_1.REG.imgtype_title)[0].replace(/\[|\]/g, '');
    var url = meta.match(reg_1.REG.imgtype_url)[0].replace(/\(|\)/g, '');
    jsx.push(react_1.default.createElement("div", { key: url + title + i },
        react_1.default.createElement("a", { href: url, title: url }, title)));
};
var renderHR = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    jsx.push(react_1.default.createElement("hr", { key: i }));
};
